﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;
using CommonBehaviors.Actions;
using System.Runtime.InteropServices;
using System.Windows.Forms;
namespace Tricks
{
    public partial class Routine
    {


        //INTERRUPTING
        public bool EnableInterrupting = true;
        public bool EnableKick = true;
        public bool EnableGougeInterrupt = true;
        public bool EnableKidneyShotInterrupt = false;
        public int CastTimeLeftInMS = 900;
        
        //GENERAL
        public bool EnableAlwaysStealth = true;
        public bool EnableAutoKidney = true;
        public bool EnableTricks = false;
        public bool EnableAutoFeint = true;
        public bool EnableWillOfTheForsaken = true;
        public int LastStealthCheckMS = 500;
        public int ScanForTricksCheckMS = 1000;

        //FINISHERS
        public bool EnableFinishers = true;
        public bool EnableKeepSliceAndDice = true;
        public bool EnablePremeditationSliceandDice = true;
        
        public int SliceAndDiceComboPointsMin = 2;
        public int SliceAndDiceComboPointsMax = 4;
        public bool EnableKeepRecuperate = false;
        public int RecuperateComboPoints = 3;
        public bool EnableEviscerate = true;

        //OPENERS
        public bool EnableOpeners = true;
        public bool EnableSapOpener = true;
        public bool EnableGarroteOpener = true;
        public bool EnableCheapShotOpener = true;
        public bool EnableSapStealthy = true;
        public bool EnableSapMode = true;

        //TALENTS
        public bool EnableCloakAndDagger = true;


        //UNUSED BELOW
        //Choose your poisons
        public int MainHandPoison = 2823;
        //8679 = Wound
        //2823 = Deadly
        public int OffHandPoison = 3408;
        //5761 = MindNumbing
        //3408 = Crippling            
        //8215 = Paralytic
        //108211 = Leeching

        static HashSet<int> HS_TrickSpellIDs = new HashSet<int>()
            {
		        8092,       //Mind Blast
                124465,     //Vampiric Touch
		        109259,     //Powershot
		        6353,       //Soul Fire
                116,        //Frostbolt
                116858,     //Chaos Bolt
            };

        //Is person Crowd Controlled?
        HashSet<WoWSpellMechanic> HS_CCMechanics = new HashSet<WoWSpellMechanic>()
            {
		        WoWSpellMechanic.Banished,
                WoWSpellMechanic.Disoriented,
                WoWSpellMechanic.Charmed,
                WoWSpellMechanic.Horrified,
                WoWSpellMechanic.Incapacitated,
                WoWSpellMechanic.Polymorphed,
                WoWSpellMechanic.Sapped,
                WoWSpellMechanic.Shackled,
                WoWSpellMechanic.Asleep,
                WoWSpellMechanic.Frozen,
                WoWSpellMechanic.Invulnerable,
                WoWSpellMechanic.Invulnerable2,
                WoWSpellMechanic.Turned,
                WoWSpellMechanic.Fleeing
            };



        HashSet<int> HS_ImmuneDebuffIDs = new HashSet<int>()
            {
		        45438,      //Ice Block
		        1022,       //Hand of Protection
		        642,        //Divine Shield
                19263,      //Deterrence
                33786       //Cyclone
            };

        HashSet<int> HS_DontBreakCC = new HashSet<int>()
            {
		        20066, //Repentence
		        118,   //Polymorph
		        1499  //Freezing Trap
            };

        HashSet<int> HS_BurstingIDs = new HashSet<int>()
            {

                107574,         //"Avatar"
                12292,          //"Bloodbath"
                1719,           //"Recklessness"
                51713,          //"Shadow Dance"
                121471,         //"Shadow Blades"
                51690,          //"Killing Spree"
                102543,         //"Incarnation: King of the Jungle"
                55233           //"Vampiric Blood"
            };

        HashSet<WoWApplyAuraType> HS_IsBeasting = new HashSet<WoWApplyAuraType>()
                {
                    WoWApplyAuraType.ModAllCritChance,
                    WoWApplyAuraType.ModAttackerMeleeCritChance,
                    WoWApplyAuraType.ModAttackerMeleeCritDamage,
                    WoWApplyAuraType.ModAttackerRangedCritChance,
                    WoWApplyAuraType.ModAttackerRangedCritDamage,
                    WoWApplyAuraType.ModAttackerSpellAndWeaponCritChance,
                    WoWApplyAuraType.ModAttackerSpellCritChance,
                    WoWApplyAuraType.ModCritPercent,
                    WoWApplyAuraType.ModCritDamageBonusMelee,
                    WoWApplyAuraType.ModDamageDone,
                    WoWApplyAuraType.ModDamagePercentDone,
                    WoWApplyAuraType.ModDamagePercentDone,
                    WoWApplyAuraType.ModAttackPower,
                    WoWApplyAuraType.ModAttackPowerPct,
                    WoWApplyAuraType.ModSpellCritChanceSchool,
                    WoWApplyAuraType.ModSpellCritChance,
                    WoWApplyAuraType.ModSpellDamageOfStatPercent,
                    WoWApplyAuraType.ModStat
                };

        HashSet<int> InterruptImmuneAuraIDs = new HashSet<int>()
            {
		        89489, //Glyph of Inner Focus
		        104773, //Unending Resolve
		        31821 //Devotion Aura
            };


    }
}
